import 'package:cached_network_image/cached_network_image.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

class ProfileAvatar extends StatelessWidget {
  ProfileAvatar(
      {Key? key,
      required this.imageUrl,
      required this.background,
      required this.radius})
      : super(key: key);

  final String imageUrl;
  final Color? background;
  final double radius;

  Widget build(BuildContext context) {
    return SizedBox(
      width: 80.0,
      height: 80.0,
      child: CachedNetworkImage(
        imageUrl: imageUrl,
        imageBuilder: (context, imageProvider) => Container(
          width: radius * 2,
          height: radius * 2,
          decoration: BoxDecoration(
            border: Border.all(
              width: 2,
              color: background ?? CupertinoColors.white.withOpacity(0.8),
            ),
            shape: BoxShape.circle,
            image: DecorationImage(
              image: imageProvider,
              fit: BoxFit.cover,
            ),
          ),
        ),
        placeholder: (context, url) => CupertinoActivityIndicator(),
        errorWidget: (context, url, error) {
          print(error.toString());
          return CircleAvatar(
            backgroundColor: CupertinoColors.white.withOpacity(0.2),
            radius: radius,
            child: Icon(
              CupertinoIcons.person,
              color: CupertinoColors.white,
              size: radius * 0.75,
            ),
          );
        },
      ),
    );
  }
}
